#!/usr/local/bin/perl

=head1 スクリプト名

wemo_list.cgi - Wemoデータリスト出力

=head1 概要

メモ格納ディレクトリの memo_yyyy-mm-dd.txt ファイルのリストとwemo.cgi起動用のファイルへのリンクを生成する。

=cut
use CGI qw(:cgi);

# 環境変数の取得
$docroot = "/homepage";#$ENV{'DOCROOT'};
$cgidir = "/cgi-bin";# $ENV{'CGIDIR'};

# メモを格納するディレクトリ名
$memodir = "memo";

# メモのカテゴリのASCII文字列をキーに日本語文字列を連想配列の値として取得
# メモ格納ディレクトリにある category.txt から読み込む
if(open(IN, "<$docroot/$memodir/category_utf-8.txt")){
	while(<IN>){
		chomp;
		($catstr, $category) = split(/\t/);
		$categories{$catstr} = $category;
	}
	close(IN);
}else{
	# category.txt が無ければ、次の連想配列のデータを使う
	%categories = (
		"favor" => "お気に入り",
		"diary" => "日記",
		"memo" => "メモ",
		"sched" => "スケジュール",
		"annot" => "註釈",
		"file" => "マイドキュメント",
	);
}

# メモの最初の部分の CGI 出力
print <<HEADER;
Content-type: text/html; charset=UTF-8

<HTML>
<HEAD>
<TITLE>Wemo List</TITLE>
<META HTTP-EQUIV="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" href="/mystyle.css">
</HEAD>
<BODY>
<H3>Wemo List</H3>
<hr>
<table border>
<tr><th>Date</th><th>Categories</th><th>Title</th></tr>
HEADER

opendir(DIR, "$docroot/$memodir");
@memo = grep(/^memo_/,readdir(DIR));
closedir(DIR);
foreach $memo (sort @memo){
	open(IN, "$docroot/$memodir/$memo");
	while(<IN>){
		chomp;
		if(/^\d{4}-\d{2}-\d{2} \(\w{3}\.\)$/){
			$date = $_;
		}elsif(/^c: (.+)$/){
			$category = $1;
			$catsw = 1;
		}elsif(/^t: (.+)$/){
			$title = $1;
			$titsw = 1;
		}
		if($catsw == 1 && $titsw == 1){
			print "<tr><td><a href=\"$cgidir/wemo.cgi/$memo\">$date</a></td><td>$categories{$category}</td><td>$title</td></tr>\n" ;
			$catsw = 0;$titsw = 0;
		}
	}
	close(IN);
}
print "</table>\n";
print "<hr>\n";
print "[ <a href=\"$cgidir/wemo_edit.cgi?today=yes\">Wemo today</a> ]";
print " | [ <a href=\"$cgidir/wemo_calendar.cgi\">Calendar</a> ]\n";
print "</BODY></HTML>\n";
